#!/bin/bash

#SBATCH --job-name=DeviceQuery
#SBATCH --output=output2.txt
#SBATCH --error=output2.txt

#SBATCH --partition=cpu_test
#SBATCH --account=ams301

#SBATCH --ntasks=1
#SBATCH --cpus-per-task=8
#SBATCH --time=00:01:00

## load modules

host=`hostname`
echo $host
if [[ "x$host" == xnode* || "x$host" == xcholeski* ]]
then
  module purge
  module load intel_compiler/oneapi_2023.2.0
fi

d=`which icpx`
if [[ "x$d" == "x" ]]
then
  echo 'cannot find icpx (intel compiler)'
  exit -1
fi

d=`dirname $d`
INTEL_ROOT=`dirname $d`

## compilation

mkdir -p install/opencl

if [ -e $INTEL_ROOT/lib/libOpenCL.so ]
then
  export LD_LIBRARY_PATH=$INTEL_ROOT/lib:$LD_LIBRARY_PATH
fi

icpx -I $INTEL_ROOT/include/sycl src/opencl/deviceQuery.cpp -L $INTEL_ROOT/lib -lOpenCL -o install/opencl/deviceQuery_icpx

## execution

echo 
echo '__________________'
echo 'OpenCL deviceQuery (icpx)'
echo

install/opencl/deviceQuery_icpx

echo
