#!/bin/bash

#SBATCH --job-name=DeviceQuery
#SBATCH --output=output.txt
#SBATCH --error=output.txt

#SBATCH --partition=gpu
#SBATCH --gres=gpu:1
#SBATCH --account=ams301

#SBATCH --ntasks=1
#SBATCH --time=00:01:00

## load modules

host=`hostname`
echo $host
if [[ "x$host" == xcholesky* ]]
then
  module purge
  module load gcc/13.2.0
  module load cuda/12.4
fi

## compilation

echo nvcc add_vectors.cu -o add_vectors
nvcc add_vectors.cu -o add_vectors

echo nvcc add_matrices.cu -o add_matrices
nvcc add_matrices.cu -o add_matrices

echo nvcc add_matrices2.cu -o add_matrices2
nvcc add_matrices2.cu -o add_matrices2

