#! /bin/bash

#SBATCH --job-name=AdditionS
#SBATCH --output=output.txt
#SBATCH --error=output.txt

#SBATCH --partition=gpu
#SBATCH --gres=gpu:1
#SBATCH --account=ams301

#SBATCH --ntasks=1
#SBATCH --cpus-per-task=8
#SBATCH --time=00:03:00

## load modules

host=`hostname`
if [[ "x$host" == xcholesky* || "x$host" == xnode* ]]
then
  module purge
  module load cmake/3.29.3
  module load gcc/13.2.0
  module load cuda/12.4
fi
c=`which nvcc`
c=`dirname $c`
export CUDA_HOME=`dirname $c`

## compilation

export OCL_ROOT=${CUDA_HOME}

cmake -DOpenCL_LIBRARY=${OCL_ROOT}/lib64/libOpenCL.so \
      -DOpenCL_INCLUDE_DIR=${OCL_ROOT}/include \
      -B build -S src -DCMAKE_INSTALL_PREFIX=install

make VERBOSE=1 -C build --no-print-directory install

## execution

export OMP_NUM_THREADS=8

for v in CPU CPU_OpenMP Cuda OpenCL Cuda_reduction OpenCL_reduction
do
  install/addition_$v
done