#ifndef __OPENCL_HXX__
#define __OPENCL_HXX__

#include <cstdlib>

#ifndef CL_TARGET_OPENCL_VERSION
#define CL_TARGET_OPENCL_VERSION 300
#endif

#ifdef __APPLE__
#include <OpenCL/opencl.h>
#else
#include <CL/opencl.h>
#endif

#include <iostream>

#define CheckOpenCL(function)                   \
  if (errcode != CL_SUCCESS) {			\
    std::cerr << __FILE__                       \
              << " (" << __LINE__ << ") : "	\
              << function << " : error code "	\
              << errcode << std::endl;          \
      std::exit(errcode);			\
  }

class OpenCL
{
public:
  OpenCL();
  ~OpenCL();
  
  cl_kernel new_kernel (const char * kernelName,
			                  const char * fileName,
                        const char * header = NULL);

  void free_kernel(cl_kernel &k);
  
  cl_mem allocate(size_t s);
  void deallocate(cl_mem & p);

  void memcpyHostToDevice(double *h, cl_mem d, size_t n);
  void memcpyDeviceToHost(cl_mem d, double *h, size_t n);
  
  void info();
  
  cl_platform_id platform_id;
  cl_device_id device_id;   
  cl_context context;
  cl_command_queue command_queue;

};

#ifndef IN_MAIN
extern 
#endif
int T_AllocId, T_CopyId, T_CompileId, T_InitId, T_AddId, T_VerifId, T_FreeId;

#endif
