#ifndef __TIMERCL__
#define __TIMERCL__

#include "timer.hxx"

#ifndef CL_TARGET_OPENCL_VERSION
#define CL_TARGET_OPENCL_VERSION 300
#endif

#ifdef __APPLE__
#include <OpenCL/opencl.h>
#else
#include <CL/opencl.h>
#endif

class TimerCL : public Timer {
public:

  TimerCL(const char *name, int o = 0, cl_command_queue q = NULL) : Timer(name, o), m_q(q) {
  }

  ~TimerCL() {
  }

  void setQueue(cl_command_queue q)
  {
     m_q = q;
  }

  void stop() {
    if (m_q) clFinish(m_q);
    Timer::stop();
  }
  
  cl_command_queue m_q;
};

#endif
